#!/usr/bin/perl
# side_effect.pl
use v5.10;

use Benchmark;

my $regex       = qr/\.pl\z/;
my @files = glob( $ARGV[0] );

my $grep_prefix = int( rand( 10 ) );
my $map_prefix  = int( rand( 10 ) );

my $code = {
    "$grep_prefix-grep"    => sub {
        push @files, scalar grep /$regex/, @files;
        return \@files;
        },
    "$map_prefix-map"     => sub {
        push @files, () = map { /$regex/ } @files;
        return \@files;
        },
    };

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
my $iterations = 1000;
print "Timing for $iterations iterations\n";

timethese( $iterations, $code );