#!/usr/bin/perl
# die_with_blessed_reference.pl

use Hash::AsObject;
use Data::Dumper;

my $result = eval {
    my $error = Hash::AsObject->new(
        {   'line'    => __LINE__ - 1,
            'package' => __PACKAGE__,
            'type'    => 'Demonstration',
            'message' => 'See, it works!',
        } );

    die $error;
    };

if( defined $@ and length $@ ) {
    my $error = $@; # save it! $@ might be reset later

    print "Error type: " . $error->type . "\n" .
        "\t"    . $error->message . "\n",
        "\tat " . $error->package . " at line " . $error->line . "\n";
    }