#!/usr/bin/perl
# log4perl_dbi.pl

use Log::Log4perl;

Log::Log4perl::init( 'dbi_logger.conf' );

my $logger = Log::Log4perl->get_logger;

$logger->warn( "I've got something to say!" );

BEGIN {
    # create the database if it doesn't already exist
    unless( -e 'csvdb' ) {
        use DBI;

        $dbh = DBI->connect("DBI:CSV:f_dir=.")
                        or die "Cannot connect: " . $DBI::errstr;
        $dbh->do(<<"HERE") or die "Cannot prepare: " . $dbh->errstr();
            CREATE TABLE csvdb (
                pid INTEGER,
                level   CHAR(64),
                file    CHAR(64),
                line    INTEGER,
                message CHAR(64)
                )
            HERE

        $dbh->disconnect();
        }
    }